# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Teams do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :TeamKeyNumeric,
    :TeamLeadKeyNumeric,
    :OriginatingSystemID,
    :OriginatingSystemKey,
    :OriginatingSystemName,
    :SourceSystemID,
    :SourceSystemKey,
    :SourceSystemName,
    :TeamAddress1,
    :TeamAddress2,
    :TeamCarrierRoute,
    :TeamCity,
    :TeamDescription,
    :TeamDirectPhone,
    :TeamEmail,
    :TeamFax,
    :TeamKey,
    :TeamLeadKey,
    :TeamLeadLoginId,
    :TeamLeadMlsId,
    :TeamLeadNationalAssociationId,
    :TeamLeadStateLicense,
    :TeamMobilePhone,
    :TeamName,
    :TeamOfficePhone,
    :TeamOfficePhoneExt,
    :TeamPostalCode,
    :TeamPostalCodePlus4,
    :TeamPreferredPhone,
    :TeamPreferredPhoneExt,
    :TeamTollFreePhone,
    :TeamVoiceMail,
    :TeamVoiceMailExt,
    :SocialMediaType,
    :TeamCountry,
    :TeamCountyOrParish,
    :TeamLeadStateLicenseState,
    :TeamStateOrProvince,
    :TeamStatus,
    :ModificationTimestamp,
    :OriginalEntryTimestamp,
    :TeamLead,
    :OriginatingSystem,
    :SourceSystem,
    :BuyerTeamProperties,
    :ListTeamProperties
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :TeamKeyNumeric => float() | nil,
    :TeamLeadKeyNumeric => float() | nil,
    :OriginatingSystemID => float() | nil,
    :OriginatingSystemKey => String.t | nil,
    :OriginatingSystemName => String.t | nil,
    :SourceSystemID => float() | nil,
    :SourceSystemKey => String.t | nil,
    :SourceSystemName => String.t | nil,
    :TeamAddress1 => String.t | nil,
    :TeamAddress2 => String.t | nil,
    :TeamCarrierRoute => String.t | nil,
    :TeamCity => String.t | nil,
    :TeamDescription => String.t | nil,
    :TeamDirectPhone => String.t | nil,
    :TeamEmail => String.t | nil,
    :TeamFax => String.t | nil,
    :TeamKey => String.t | nil,
    :TeamLeadKey => String.t | nil,
    :TeamLeadLoginId => String.t | nil,
    :TeamLeadMlsId => String.t | nil,
    :TeamLeadNationalAssociationId => String.t | nil,
    :TeamLeadStateLicense => String.t | nil,
    :TeamMobilePhone => String.t | nil,
    :TeamName => String.t | nil,
    :TeamOfficePhone => String.t | nil,
    :TeamOfficePhoneExt => String.t | nil,
    :TeamPostalCode => String.t | nil,
    :TeamPostalCodePlus4 => String.t | nil,
    :TeamPreferredPhone => String.t | nil,
    :TeamPreferredPhoneExt => String.t | nil,
    :TeamTollFreePhone => String.t | nil,
    :TeamVoiceMail => String.t | nil,
    :TeamVoiceMailExt => String.t | nil,
    :SocialMediaType => String.t | nil,
    :TeamCountry => String.t | nil,
    :TeamCountyOrParish => String.t | nil,
    :TeamLeadStateLicenseState => String.t | nil,
    :TeamStateOrProvince => String.t | nil,
    :TeamStatus => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :TeamLead => FoyerAPI.Model.Member.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :BuyerTeamProperties => FoyerAPI.Model.Property.t | nil,
    :ListTeamProperties => FoyerAPI.Model.Property.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Teams do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:TeamLead, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:BuyerTeamProperties, :struct, FoyerAPI.Model.Property, options)
    |> deserialize(:ListTeamProperties, :struct, FoyerAPI.Model.Property, options)
  end
end

